#include "stm32f10x.h"                  // Device header
#include "Delay.h"
#include "Serial.h"
#include "FreeRTOS.h"
#include "task.h"
#include <stdlib.h>
#include "PWM.h"
#include "pin.h"
#include "AD.h"



//int rxDate=4568;
uint8_t gval=0;
uint8_t gmode=0;
uint8_t gtype=0;

void task_1_function(void *argument);
void task_2_function(void *argument);
void task_3_function(void *argument);

int main(void)
{
	/*模块初始化*/
	Serial_Init();		//串口初始化
	PWM_Init();     //PWM初始化
	pin_Init();
	AD_Init();
	PWM_SetCompare2(138);
	PWM_SetCompare1(150);
	//GPIO_ResetBits(GPIOB, GPIO_Pin_10);
	xTaskCreate(task_1_function, "Task 1", 128, NULL, 1, NULL);
	xTaskCreate(task_2_function, "Task 2", 128, NULL, 2, NULL);
	xTaskCreate(task_3_function, "Task 3", 128, NULL,3, NULL);
	//xTaskCreate(task_4_function, "Task 4", 128, NULL,3, NULL);
		
	vTaskStartScheduler();
	
	
	 
	while (1)
	{
		
	}
	
}

void task_1_function(void *argument)
{
	//(void)argument;
	while(1)
	{
		//pinBSet(10,1);
		//Serial_SendByte(0xAA);
		//Serial_SendByte(0x02);
		//Serial_SendByte(0x02);
		//Serial_SendByte(0xFE);
		
		if (Serial_GetRxFlag() == 1)
		{
			
			//return ;
		
			gtype=Serial_RxPacket[0];
			gmode=Serial_RxPacket[1];
			gval=Serial_RxPacket[2];
				//Serial_SendByte(0xAA);
		//Serial_SendString(Serial_RxPacket);
			//PWM_SetCompare2(180);
			switch(gtype)
			{
				case 1:
					mn_control(gmode,gval);
					break;
				case 0xEE:
					pinBSet(gmode,gval);
					break;
				default:
					break;
			}
			gtype=0;
			//gmode=0; 
			
			//gnumber=0;
		}
		vTaskDelay(pdMS_TO_TICKS(10));
	}	
}


void task_2_function(void *argument)
{
	//(void)argument;
	while(1)
	{
		
	uint8_t AD4=AD_GetValue(ADC_Channel_4);
	uint8_t AD5=AD_GetValue(ADC_Channel_5);
	uint8_t AD6=AD_GetValue(ADC_Channel_6);
	uint8_t AD7=AD_GetValue(ADC_Channel_7);
		
	//Serial_SendPacket(0xFE);		
	//Serial_SendByte(power);
	
	vTaskDelay(pdMS_TO_TICKS(1000));	
	}	
	
}

void task_3_function(void *argument)
{
	//(void)argument;
	int readpin=0;
	while(1)
	{
		
		//0
		readpin=Read_Apin();
		switch(readpin)
		{
			case 1:
				Serial_SendByte(0xAA);
				Serial_SendByte(0x01);
				Serial_SendByte(0xFE);
				readpin=0;
				break;
			case 2:
				Serial_SendByte(0xAA);
				Serial_SendByte(0x02);
				Serial_SendByte(0xFE);
				readpin=0;
				break;
			case 3:
				Serial_SendByte(0xAA);
				Serial_SendByte(0x03);
				Serial_SendByte(0xFE);
				readpin=0;	
				break;
			case 4:
				Serial_SendByte(0xAA);
				Serial_SendByte(0x04);
				Serial_SendByte(0xFE);	
				readpin=0;	
				break;   
			default:
				break;
				
		}
			
		vTaskDelay(pdMS_TO_TICKS(500));
	}
	
}
